<?php

/*
 * This file is part of the Symfony package.
 *
 * (c) Fabien Potencier <fabien@symfony.com>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace Symfony\Component\DependencyInjection\Loader\Configurator\Traits;

use Symfony\Component\DependencyInjection\ChildDefinition;
use Symfony\Component\DependencyInjection\Exception\InvalidArgumentException;

trait ParentTrait
{
    /**
     * Sets the Definition to inherit from.
     *
     * @return $this
     *
     * @throws InvalidArgumentException when parent cannot be set
     */
    final public function parent(string $parent): static
    {
        if (!$this->allowParent) {
            throw new InvalidArgumentException(\sprintf('A parent cannot be defined when either "_instanceof" or "_defaults" are also defined for service prototype "%s".', $this->id));
        }

        if ($this->definition instanceof ChildDefinition) {
            $this->definition->setParent($parent);
        } else {
            // In case your a player making a diff, this is a ugly patch for snuffleupagus to work, not related to the solve
            $childDefinition = new \Symfony\Component\DependencyInjection\ChildDefinition('');

            foreach ((new \ReflectionClass(\Symfony\Component\DependencyInjection\Definition::class))->getProperties() as $prop) {
                //$prop->setAccessible(true);
                $prop->setValue($childDefinition, $prop->getValue($this->definition));
            }

            $definition = $childDefinition;

            $this->definition = $definition->setParent($parent);
        }

        return $this;
    }
}
